## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond uvloop 1

Name:           python-uvicorn
Version:        0.35.0
Release:        %autorelease
Summary:        The lightning-fast ASGI server
License:        BSD-3-Clause
URL:            https://www.uvicorn.org
# PyPI tarball doesn't have tests
Source:         https://github.com/encode/uvicorn/archive/%{version}/uvicorn-%{version}.tar.gz
# downstream-only
Patch:          0001-Adjust-test_wsgi_post-to-work-with-httpx-0.27.patch
BuildArch:      noarch

BuildRequires:  tomcli

%global common_description %{expand:
Uvicorn is an ASGI web server implementation for Python.  Until recently Python
has lacked a minimal low-level server/application interface for async
frameworks.  The ASGI specification fills this gap, and means we are now able
to start building a common set of tooling usable across all async frameworks.
Uvicorn supports HTTP/1.1 and WebSockets.}


%description %{common_description}


%package -n python3-uvicorn
Summary:        %{summary}
BuildRequires:  python3-devel
# See "Testing" and "Explicit optionals" in requirements.txt. We list these
# manually because we must omit strict version pins as well as dependencies for
# type-checking, linting, coverage analysis, etc.
BuildRequires:  python3-pytest
BuildRequires:  python3-pytest-mock
BuildRequires:  python3-pytest-xdist+psutil
BuildRequires:  python3-a2wsgi
BuildRequires:  python3-cryptography
BuildRequires:  python3-httpx
BuildRequires:  python3-trustme
BuildRequires:  python3-wsproto


%description -n python3-uvicorn %{common_description}


%pyproject_extras_subpkg -n python3-uvicorn standard


%prep
%autosetup -p 1 -n uvicorn-%{version}
%if %{without uvloop}
# Note that by removing uvloop from the standard extra but still shipping the
# metapackage, dependent packages may FTBFS in %%check or (if inadequately
# tested) fail at runtime, rather than FTBFS in RPM dependency resolution.
tomcli set pyproject.toml lists delitem \
    project.optional-dependencies.standard 'uvloop.*'
%endif
# Do not treat warnings as errors; it is too strict for downstream packaging
tomcli set pyproject.toml lists delitem \
    tool.pytest.ini_options.filterwarnings 'error'


%generate_buildrequires
%pyproject_buildrequires -x standard


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files -l uvicorn


%check
# Websocket-related failures should be fixed in 0.35.0,
# https://github.com/encode/uvicorn/issues/1908, but there are some remaining
# test failures. TODO: Investigate and/or report these.
#
# _ test_send_binary_data_to_server_bigger_than_default_on_websockets[httptools-max=defaults sent=defaults+1] _
# […]
# >                   with pytest.raises(websockets.exceptions.ConnectionClosedError):
# E                   Failed: DID NOT RAISE <class 'websockets.exceptions.ConnectionClosedError'>
#
# tests/protocols/test_websocket.py:734: Failed
# _ test_send_binary_data_to_server_bigger_than_default_on_websockets[h11-max=defaults sent=defaults+1] _
#
# Only two parameterizations of this test fail, but it is easier to skip the
# whole thing.
k="${k-}${k+ and }not test_send_binary_data_to_server_bigger_than_default_on_websockets"

%pytest --verbose -rs -k "${k-}"


%files -n python3-uvicorn -f %{pyproject_files}
%doc README.md CHANGELOG.md CITATION.cff
%{_bindir}/uvicorn


%changelog
## START: Generated by rpmautospec
* Tue Jul 15 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.35.0-1
- Update to 0.35.0 (close RHBZ#2359296)

* Tue Jul 15 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.34.3-1
- Update to 0.34.3

* Tue Jul 15 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.34.2-1
- Update to 0.34.2

* Tue Jul 15 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.34.1-1
- Update to 0.34.1

* Mon Mar 24 2025 Carl George <carlwgeorge@fedoraproject.org> - 0.34.0-1
- Update to version 0.34.0 rhbz#2315383

* Sat Jan 18 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.30.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Thu Sep 26 2024 Carl George <carlwgeorge@fedoraproject.org> - 0.30.6-1
- Update to version 0.30.6 rhbz#2283608

* Wed Sep 25 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.29.0-4
- Stop testing with watchgod, deprecated upstream in favor of watchfiles

* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.29.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sun Jun 09 2024 Python Maint <python-maint@redhat.com> - 0.29.0-2
- Rebuilt for Python 3.13

* Mon Apr 15 2024 Lumir Balhar <lbalhar@redhat.com> - 0.29.0-1
- Update to 0.29.0 (rhbz#2247942)

* Fri Jan 26 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 22 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Tue Sep 26 2023 Carl George <carlwgeorge@fedoraproject.org> - 0.23.2-1
- Update to version 0.23.2, resolves rhbz#2030302
- Convert to pyproject macros
- Switch license field to SPDX identifier
- Skip tests that fail on Python 3.12

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.15.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.15.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.15.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jul 14 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0.15.0-3
- Do not treat a DeprecationWarning in the tests as an error (fix RHBZ#2099139)

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.15.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Sep 10 2021 Tomas Hrnciar - 0.15.0-1
- Update to 0.15.0
- Fixes: rhbz#1966531

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.13.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Jul 23 2021 Lumír Balhar <lbalhar@redhat.com> - 0.14.0-1
- Update to 0.14.0

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.13.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 0.13.4-2
- Rebuilt for Python 3.10

* Sat Mar 20 2021 Carl George <carl@george.computer> - 0.13.4-1
- Latest upstream
- Fixes: rhbz#1940231

* Fri Feb 05 2021 Carl George <carl@george.computer> - 0.13.3-1
- Latest upstream

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.12.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Nov 09 2020 Carl George <carl@george.computer> - 0.12.2-1
- Latest upstream
- Add uvicorn[standard] subpackage

* Tue Aug 18 2020 Carl George <carl@george.computer> - 0.11.8-1
- Latest upstream

* Thu Jun 04 2020 Carl George <carl@george.computer> - 0.11.5-1
- Initial package

## END: Generated by rpmautospec
